/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the ContactERConfidence type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ContactERConfidence{}

// ContactERConfidence struct for ContactERConfidence
type ContactERConfidence struct {
	FirstName *int32 `json:"first_name,omitempty"`
	LastName *int32 `json:"last_name,omitempty"`
	Gender *int32 `json:"gender,omitempty"`
	Title *int32 `json:"title,omitempty"`
}

// NewContactERConfidence instantiates a new ContactERConfidence object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContactERConfidence() *ContactERConfidence {
	this := ContactERConfidence{}
	return &this
}

// NewContactERConfidenceWithDefaults instantiates a new ContactERConfidence object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactERConfidenceWithDefaults() *ContactERConfidence {
	this := ContactERConfidence{}
	return &this
}

// GetFirstName returns the FirstName field value if set, zero value otherwise.
func (o *ContactERConfidence) GetFirstName() int32 {
	if o == nil || IsNil(o.FirstName) {
		var ret int32
		return ret
	}
	return *o.FirstName
}

// GetFirstNameOk returns a tuple with the FirstName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactERConfidence) GetFirstNameOk() (*int32, bool) {
	if o == nil || IsNil(o.FirstName) {
		return nil, false
	}
	return o.FirstName, true
}

// HasFirstName returns a boolean if a field has been set.
func (o *ContactERConfidence) HasFirstName() bool {
	if o != nil && !IsNil(o.FirstName) {
		return true
	}

	return false
}

// SetFirstName gets a reference to the given int32 and assigns it to the FirstName field.
func (o *ContactERConfidence) SetFirstName(v int32) {
	o.FirstName = &v
}

// GetLastName returns the LastName field value if set, zero value otherwise.
func (o *ContactERConfidence) GetLastName() int32 {
	if o == nil || IsNil(o.LastName) {
		var ret int32
		return ret
	}
	return *o.LastName
}

// GetLastNameOk returns a tuple with the LastName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactERConfidence) GetLastNameOk() (*int32, bool) {
	if o == nil || IsNil(o.LastName) {
		return nil, false
	}
	return o.LastName, true
}

// HasLastName returns a boolean if a field has been set.
func (o *ContactERConfidence) HasLastName() bool {
	if o != nil && !IsNil(o.LastName) {
		return true
	}

	return false
}

// SetLastName gets a reference to the given int32 and assigns it to the LastName field.
func (o *ContactERConfidence) SetLastName(v int32) {
	o.LastName = &v
}

// GetGender returns the Gender field value if set, zero value otherwise.
func (o *ContactERConfidence) GetGender() int32 {
	if o == nil || IsNil(o.Gender) {
		var ret int32
		return ret
	}
	return *o.Gender
}

// GetGenderOk returns a tuple with the Gender field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactERConfidence) GetGenderOk() (*int32, bool) {
	if o == nil || IsNil(o.Gender) {
		return nil, false
	}
	return o.Gender, true
}

// HasGender returns a boolean if a field has been set.
func (o *ContactERConfidence) HasGender() bool {
	if o != nil && !IsNil(o.Gender) {
		return true
	}

	return false
}

// SetGender gets a reference to the given int32 and assigns it to the Gender field.
func (o *ContactERConfidence) SetGender(v int32) {
	o.Gender = &v
}

// GetTitle returns the Title field value if set, zero value otherwise.
func (o *ContactERConfidence) GetTitle() int32 {
	if o == nil || IsNil(o.Title) {
		var ret int32
		return ret
	}
	return *o.Title
}

// GetTitleOk returns a tuple with the Title field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactERConfidence) GetTitleOk() (*int32, bool) {
	if o == nil || IsNil(o.Title) {
		return nil, false
	}
	return o.Title, true
}

// HasTitle returns a boolean if a field has been set.
func (o *ContactERConfidence) HasTitle() bool {
	if o != nil && !IsNil(o.Title) {
		return true
	}

	return false
}

// SetTitle gets a reference to the given int32 and assigns it to the Title field.
func (o *ContactERConfidence) SetTitle(v int32) {
	o.Title = &v
}

func (o ContactERConfidence) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ContactERConfidence) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.FirstName) {
		toSerialize["first_name"] = o.FirstName
	}
	if !IsNil(o.LastName) {
		toSerialize["last_name"] = o.LastName
	}
	if !IsNil(o.Gender) {
		toSerialize["gender"] = o.Gender
	}
	if !IsNil(o.Title) {
		toSerialize["title"] = o.Title
	}
	return toSerialize, nil
}

type NullableContactERConfidence struct {
	value *ContactERConfidence
	isSet bool
}

func (v NullableContactERConfidence) Get() *ContactERConfidence {
	return v.value
}

func (v *NullableContactERConfidence) Set(val *ContactERConfidence) {
	v.value = val
	v.isSet = true
}

func (v NullableContactERConfidence) IsSet() bool {
	return v.isSet
}

func (v *NullableContactERConfidence) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactERConfidence(val *ContactERConfidence) *NullableContactERConfidence {
	return &NullableContactERConfidence{value: val, isSet: true}
}

func (v NullableContactERConfidence) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactERConfidence) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


